--- tools/start_new_disc~	2013-04-01 01:26:54.000000000 +0000
+++ tools/start_new_disc	2013-04-15 11:13:35.000000000 +0000
@@ -170,12 +170,20 @@
 
     echo "  Adding udeb/base includes/excludes"
 
+    # Check if the following has been set by CONF.sh
+    if [ -z "$UDEB_INCLUDE" ]; then
+        NO_UDEB_INCLUDE=1
+    fi
+    if [ -z "$UDEB_EXCLUDE" ]; then
+        NO_UDEB_EXCLUDE=1
+    fi
+
     for ARCH in $ARCHES
     do
         if [ $ARCH != source ] ; then
             # Netinst/businesscard CD have different
             # udeb_include and udeb_exclude files
-            if [ -z "$UDEB_INCLUDE" ] ; then
+            if [ -n "$NO_UDEB_INCLUDE" ] ; then
                 case "$INSTALLER_CD"x in
                     "1"x)
                         UDEB_INCLUDE=$DI_DATA_DIR/"$ARCH"_businesscard_udeb_include;;
@@ -186,7 +194,7 @@
                 esac
             fi
 
-            if [ -z "$UDEB_EXCLUDE" ] ; then
+            if [ -n "$NO_UDEB_EXCLUDE" ] ; then
                 case "$INSTALLER_CD"x in
                     "1"x)
                         UDEB_EXCLUDE=$DI_DATA_DIR/"$ARCH"_businesscard_udeb_exclude;;
@@ -200,14 +208,30 @@
             # Sort out the udeb include and exclude files
             if [ -n "$UDEB_INCLUDE" ] ; then
                 if [ -r "$UDEB_INCLUDE" ] ; then
-                    cat "$UDEB_INCLUDE" >> "$CDDIR/.disk/udeb_include"
+                    if [ -e "$CDDIR/.disk/udeb_include" ]; then
+                        if ! diff -q "$UDEB_INCLUDE" "$CDDIR/.disk/udeb_include"; then
+                            mv "$CDDIR"/.disk/udeb_include{,~}
+                            cat "$UDEB_INCLUDE" "$CDDIR/.disk/udeb_include~" | sort | uniq > "$CDDIR/.disk/udeb_include"
+                            rm "$CDDIR/.disk/udeb_include~" 
+                        fi
+                    else
+                        cp "$UDEB_INCLUDE" "$CDDIR/.disk/udeb_include"
+                    fi
                 else
                     echo "WARNING: Unable to read UDEB_INCLUDE file $UDEB_INCLUDE"
                 fi
             fi
             if [ -n "$UDEB_EXCLUDE" ] ; then
                 if [ -r "$UDEB_EXCLUDE" ] ; then
-                    cat "$UDEB_EXCLUDE" >> "$CDDIR/.disk/udeb_exclude"
+                    if [ -e "$CDDIR/.disk/udeb_exclude" ]; then
+                        if ! diff -q "$UDEB_EXCLUDE" "$CDDIR/.disk/udeb_exclude"; then
+                            mv "$CDDIR"/.disk/udeb_exclude{,~}
+                            cat "$UDEB_EXCLUDE" "$CDDIR/.disk/udeb_exclude~" | sort | uniq > "$CDDIR/.disk/udeb_exclude"
+                            rm "$CDDIR/.disk/udeb_exclude~" 
+                        fi
+                    else
+                        cp "$UDEB_EXCLUDE" "$CDDIR/.disk/udeb_exclude"
+                    fi
                 else
                     echo "WARNING: Unable to read UDEB_EXCLUDE file $UDEB_EXCLUDE"
                 fi
